/**
 *
 * SKShortcutItem.h SK`pV[gJbgNX
 *
 */

//#include "ShortcutItem.h"
#include <math.h>


///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//
// 萔
//

// ~
#define PI				(3.141593)
// ~
#define ICON_NOTFOUND	"notfound.ico"


///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//
// vg^Cv錾
//

string subStrXML(const string& word, const string& data, UINT posStt, UINT posEnd);

// skutil.h̊֐ ////////////////////////////////////////

// JgfBNg̎擾
string GetAppDir();


/**
 * V[gJbgACeNX SKShortcutItem
 */
class SKShortcutItem: public ShortcutItem
{
private:
	// o /////////////////////////

	// LvV
	// pX
	// ƃtH_̃pX
	// Rg
	// R}hC

	INT m_showCmd;			// \@
	string m_iconPath;		// ACR̃pX
	UINT m_iconIndex;		// ACR̈ʒu

	float m_r;				// a
	float m_theta;			// ʊp(0`2PI)

	int m_keyChar;			// WvL[
	char m_keyShift;		// WvL[Vtg

	HICON m_hIcon;			// ACR̃nh

	// \bh /////////////////////////

	// px𒲐
	const float trim0to2PI(float theta) const;
	const float trimMPItoPI(float theta) const;
	// getFromXML̃Tu[`
	const string subStrXML(const string& word, const string& data, UINT posStt, UINT posEnd) const;
	// ACRݒ
	const bool setIcon();
	const HICON getIconFromFile(const string& path, UINT index, bool bIconFile) const;

public:
	// Getter /////////////////////////

	const INT getShowCmd() const;		// \@
	const string& getIconPath() const;	// ACR̃pX
	const UINT getIconIndex() const;	// ACR̈ʒu
	const HICON getHIcon() const;		// ACR̃nh
	const int getKeyChar() const;		// WvL[
	const char getKeyShift() const;		// WvL[Vtg
	const float getR() const;			// a
	const float getTheta() const;		// ʊp

	// Setter /////////////////////////

	void setShowCmd(const INT arg);			// \@
	void setPath(const string& arg);		// pX
	void setIconPath(const string& arg);	// ACR̃pX
	void setIconIndex(const UINT arg);		// ACR̈ʒu
	void setKeyChar(const int arg);			// WvL[
	void setKeyShift(const char arg);		// WvL[Vtg


	// J\bh /////////////////////////

	// RXgN^
	SKShortcutItem();
	// fXgN^
	virtual ~SKShortcutItem();

    // Rs[RXgN^
    SKShortcutItem(const SKShortcutItem& other);
    // Zq
    SKShortcutItem& operator=(const SKShortcutItem& other);

	// ʒu擾
	const int getX() const;
	const int getY() const;

	// ʒuݒ
	const void setR(float r);
	const void addR(float r);
	const void setTheta(float theta);
	const void addTheta(float theta);
	const void setLoacation(float r, float theta);
	const void addLoacation(float r, float theta);

	// t@CJ
	const int fileOpen() const;
	const int folderOpen() const;
	
	// t@C݂邩ׂ
	const bool fileExist() const;
	
	// ACRt@C݂邩ׂ
	const bool iconExist() const;

	// XMLǂݍ
	const bool getFromXML(const string& data);
};


///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//
// RXgN^
//
inline SKShortcutItem::SKShortcutItem()
{
	// string^͑Sċ󕶎ŏ

	m_showCmd = SW_SHOWNORMAL;	// \@
	m_iconIndex = 0;			// ACR̈ʒu

	m_r = 0;					// a
	m_theta = 0;				// ʊp(0`2PI)

	m_keyChar = 0;				// WvL[
	m_keyShift = 0;				// WvL[Vtg

	m_hIcon = NULL;				// ACR̃nh
}


///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//
// fXgN^
//
inline SKShortcutItem::~SKShortcutItem()
{
	// ACR̍폜@
	if(iconExist()) DestroyIcon(m_hIcon);
}


///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//
// Rs[RXgN^
//
inline SKShortcutItem::SKShortcutItem(const SKShortcutItem& other)
{
	string caption(other.getCaption());
	m_caption.assign(caption);

	string path(other.getPath());
	m_path.assign(path);

	string dirPath(other.getDirPath());
	m_dirPath.assign(dirPath);
	
	string comment(other.getComment());
	m_comment.assign(comment);
	
	string parameter(other.getParameter());
	m_parameter.assign(parameter);
	
	m_showCmd = other.getShowCmd();
	
	string iconPath(other.getIconPath());
	m_iconPath.assign(iconPath);
	m_iconIndex = other.getIconIndex();

	m_keyChar = other.getKeyChar();
	m_keyShift = other.getKeyShift();

	m_r = other.getR();
	m_theta = other.getTheta();

	setIcon();
}


///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//
// Zq
//
inline SKShortcutItem& SKShortcutItem::operator=(const SKShortcutItem& other)
{
	string caption(other.getCaption());
	m_caption.assign(caption);

	string path(other.getPath());
	m_path.assign(path);

	string dirPath(other.getDirPath());
	m_dirPath.assign(dirPath);
	
	string comment(other.getComment());
	m_comment.assign(comment);
	
	string parameter(other.getParameter());
	m_parameter.assign(parameter);
	
	m_showCmd = other.getShowCmd();
	
	string iconPath(other.getIconPath());
	m_iconPath.assign(iconPath);
	
	m_iconIndex = other.getIconIndex();
	m_keyChar = other.getKeyChar();
	m_keyShift = other.getKeyShift();

	setIcon();
	return(*this);
}


//////////////////////////////////////////////////////////////////////////////////////////////////////////////////
// Getter
//////////////////////////////////////////////////////////////////////////////////////////////////////////////////

// \@
inline const INT SKShortcutItem::getShowCmd() const
{
	return m_showCmd;
}

// ACR̃pX
inline const string& SKShortcutItem::getIconPath() const
{
	return m_iconPath;
	m_r;
}

// ACR̈ʒu
inline const UINT SKShortcutItem::getIconIndex() const
{
	return m_iconIndex;
}

// ACR̃nh
inline const HICON SKShortcutItem::getHIcon() const
{
	return m_hIcon;
}

// WvL[
inline const int SKShortcutItem::getKeyChar() const
{
	return m_keyChar;
}

// WvL[Vtg
inline const char SKShortcutItem::getKeyShift() const
{
	return m_keyShift;
}

// a
inline const float SKShortcutItem::getR() const
{
	return m_r;
}

// ʊp
inline const float SKShortcutItem::getTheta() const
{
	return m_theta;
}


//////////////////////////////////////////////////////////////////////////////////////////////////////////////////
// Setter
//////////////////////////////////////////////////////////////////////////////////////////////////////////////////

// \@
inline void SKShortcutItem::setShowCmd(const INT arg)
{
	m_showCmd = arg;
}

// pX
inline void SKShortcutItem::setPath(const string& arg)
{
	string s(arg);
	m_path.assign(s);
	setIcon();
}

// ACR̃pX
inline void SKShortcutItem::setIconPath(const string& arg)
{
	string s(arg);
	m_iconPath.assign(s);
	setIcon();
}

// ACR̈ʒu
inline void SKShortcutItem::setIconIndex(const UINT arg)
{
	m_iconIndex = arg;
	setIcon();
}

// WvL[
inline void SKShortcutItem::setKeyChar(const int arg)
{
	m_keyChar = arg;
}

// WvL[Vtg
inline void SKShortcutItem::setKeyShift(const char arg)
{
	m_keyShift = arg;
}


///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//
// ʒu擾
//
inline const int SKShortcutItem::getX() const
{
	float x = m_r * cos(m_theta) + 0.5;
	return (int)x;
}

inline const int SKShortcutItem::getY() const
{
	float y = m_r * sin(m_theta) + 0.5;
	return (int)y;
}


///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//
// ʒuݒ
//
inline const void SKShortcutItem::setR(float r)
{
	if(r < 0)	m_r = 0;
	else		m_r = r;
}

inline const void SKShortcutItem::addR(float r)
{
	if(m_r + r < 0)	m_r = 0;
	else			m_r += r;
}

inline const void SKShortcutItem::setTheta(float theta)
{
	m_theta = trim0to2PI(theta);
}

inline const void SKShortcutItem::addTheta(float theta)
{
	m_theta = trim0to2PI(m_theta+theta);
}

inline const void SKShortcutItem::setLoacation(float r, float theta)
{
	setR(r);
	setTheta(theta);
}

inline const void SKShortcutItem::addLoacation(float r, float theta)
{
	addR(r);
	addTheta(theta);
}


///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//
// 02PI͈̔͂ɂ
//
inline const float SKShortcutItem::trim0to2PI(float theta) const
{
	float ret = theta;

	// ͈͊O̊ԃ[v
	while(ret < 0 || ret >= 2 * PI){
		if(ret < 0)	ret += (float)(2 * PI);
		else		ret -= (float)(2 * PI);
	}
	return ret;
}

///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//
// -PIPI͈̔͂ɂ
//
inline const float SKShortcutItem::trimMPItoPI(float theta) const
{
	float ret = theta;

	// ͈͊O̊ԃ[v
	while(ret < -PI || ret >= PI){
		if(ret < -PI)	ret += (float)(2 * PI);
		else			ret -= (float)(2 * PI);
	}
	return ret;
}


///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//
// t@CJ(:0, G[:0ȊÕG[萔)
//
inline const int SKShortcutItem::fileOpen() const
{
	int ret;
	ret = (int)ShellExecute(0, NULL, m_path.c_str(), m_parameter.c_str(), m_dirPath.c_str(), m_showCmd);
	
	if(ret<=32)	return ret;
	else		return 0;
}


///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//
// t@CJ(:0, G[:0ȊÕG[萔)
//
inline const int SKShortcutItem::folderOpen() const
{
	int ret;
	ret = (int)ShellExecute(0, NULL, m_dirPath.c_str(), m_parameter.c_str(), m_dirPath.c_str(), SW_SHOWNORMAL);
	
	if(ret<=32)	return ret;
	else		return 0;
}


///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//
// t@C݂邩ׂ
//
inline const bool SKShortcutItem::fileExist() const
{
	return( GetFileAttributes(m_path.c_str()) != (DWORD)-1 );
}


///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//
// ACRt@C݂邩ׂ
//
inline const bool SKShortcutItem::iconExist() const
{
	if(m_path.compare("") != 0)
		if(GetFileAttributes(m_path.c_str()) != (DWORD)-1)
			return true;
		else
			return false;
	else
		if(GetFileAttributes(m_iconPath.c_str()) != (DWORD)-1)
			return true;
		else
			return false;
}


///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//
// XMLǂݍ
//
inline const bool SKShortcutItem::getFromXML(const string& data)
{
	UINT posStt, posEnd;
	string buff;

	// posStt, posEnd̐ݒ
	posStt = data.find("<ShortcutItem>", 0);
	if(posStt == string::npos) return false;	// Ȃꍇs
	buff = "</ShortcutItem>";
	posEnd = data.find(buff, 0);
	if(posEnd == string::npos) return false;	// Ȃꍇs
	posEnd += buff.length();

	// LvV
	buff = subStrXML("Caption", data, posStt, posEnd);
	if(buff != "")	m_caption = buff;
	else			return false;		// K{
	// pX
	buff = subStrXML("Path", data, posStt, posEnd);
	if(buff != "")	m_path = buff;
	else			return false;		// K{
	// Rg
	buff = subStrXML("Comment", data, posStt, posEnd);
	if(buff != "")	m_comment = buff;
	else			m_comment = "";
	// ƃpX
	buff = subStrXML("DirPath", data, posStt, posEnd);
	if(buff != "")	m_dirPath = buff;
	else			m_dirPath = "";
	// R}hC
	buff = subStrXML("Param", data, posStt, posEnd);
	if(buff != "")	m_parameter = buff;
	else			m_parameter = "";
	// \@
	buff = subStrXML("ShowCmd", data, posStt, posEnd);
	if(buff != "")	m_showCmd = atoi(buff.c_str());
	else			m_showCmd = 0;
	// ACR̃pX
	buff = subStrXML("IconPath", data, posStt, posEnd);
	if(buff != "")	m_iconPath = buff;
	else			m_iconPath = "";
	// ACR̈ʒu
	buff = subStrXML("IconIndex", data, posStt, posEnd);
	if(buff != "")	m_iconIndex = atoi(buff.c_str());
	else			m_iconIndex = 0;
	// WvL[
	buff = subStrXML("KeyChar", data, posStt, posEnd);
	if(buff != "")	m_keyChar = atoi(buff.c_str());
	else			m_keyChar = 0;
	// WvL[Vtg
	buff = subStrXML("KeyShift", data, posStt, posEnd);
	if(buff != "")	m_keyShift = atoi(buff.c_str());
	else			m_keyShift = 0;

	return true;	// 
}

///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//
// getFromXML̃Tu[`
//
inline const string SKShortcutItem::subStrXML(const string& word, const string& data, UINT posStt, UINT posEnd) const
{
	UINT pos1, pos2;

	// {<word}  {>} ̌
	pos1 = data.find("<" + word, posStt);
	if(pos1 == string::npos) return "";	// ȂȂ玸s
	pos2 = data.find(">", pos1);
	if(pos2 == string::npos) return "";	// ȂȂ玸s

	// {<word>`</word>} 𔻒f
	if( data.substr(pos2-1, 1).compare("/") != 0 && pos2 < posEnd){
		pos1 = pos2 + 1;
		pos2 = data.find("</" + word + ">", pos1);
		
		if(pos1 == pos2) return "";	// 󕶎Ȃ玸s

		return data.substr(pos1, pos2 - pos1);

	}else return "";
}


///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//
// ACRݒ
//
inline const bool SKShortcutItem::setIcon()
{
	if( iconExist() ){
		// ACRt@CȂ
		DestroyIcon(m_hIcon);		// ̃ACR폜
		if(m_iconPath.compare("") == 0){
			// ACRt@Cw肳ĂȂȂ
			m_hIcon = getIconFromFile(m_path.c_str(), NULL, false);
			
		}else{
			// ACRt@Cw肳ĂȂ
			m_hIcon = getIconFromFile(m_iconPath.c_str(), m_iconIndex, true);
		}
		return true;

	}else{
		// ACRt@CȂȂNOT FOUNDACR
		string s;
		s = GetAppDir() + "\\" + ICON_NOTFOUND;
        m_hIcon = getIconFromFile(s, 0, true);
		return false;
	}
}


///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//
// t@CACR擾
//
inline const HICON SKShortcutItem::getIconFromFile(const string& path, UINT index, bool bIconFile) const
{
	if(bIconFile){
		// ACRt@C(exe,ico,dll,icl)Ȃ
		HICON hIcon;
		ExtractIconEx(path.c_str(), (int)index, &hIcon, NULL, 1);
		return hIcon;

	}else{
		// ACRt@CłȂȂ
		SHFILEINFOA fi;
		SHGetFileInfo(path.c_str(), FILE_ATTRIBUTE_ARCHIVE, &fi, sizeof(fi), SHGFI_ICON | SHGFI_LARGEICON);
		return fi.hIcon;
	}
}
